<?php

   /*
   Copyright (C) 2001
   by Justin Woods <woodsj@swau.edu>
   and David Sowder <davids@swau.edu>
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   */

   // $Id: webstamp.inc,v 1.17 2001/08/21 18:05:18 davids Exp $

function get_needed_tags_list($workingset) {
  preg_match_all("/\{([^}]+)\}/", $workingset, $m);
  $m = $m[1];
  if (!is_array($m))
    return array();

  reset($m);
  while(list($k, $v) = each($m)) {
    if (!isset($result[$v])) {
      $result[$v] = $v;
    }
  }
  
  if (count($result))
    return $result;
  else
    return array();
}

function get_directory_steps_to_libs_dir($directory) {
   while( $directory = dirname($directory) ) {
      $dir_list[] = $directory;
      if( $directory == '/') {
         break;
      }
      elseif( file_exists($directory . '/.libs') ) {
         $dir_list[] = $directory . '/.libs';
         break;
      }
   }
   return array_reverse($dir_list);
}

function get_gfx_matched_url($gfx,$url) {
   $gfx = $gfx . '/';
   while( !strncmp( $gfx, '../', 3 )) {
     $gfx = substr( $gfx, 3 );
     $url = dirname( $url ) . '/';
     }
   return $url;
}

function get_file_list( $directory, $prefix = '' ) {
   global $OURLIBS;
   $prefix = !empty($prefix) ? '\\'.$prefix : '';
   $d = dir($directory);
   $file_list = array();
   while( $file = $d->read() ) {
      if( ereg('^' . $prefix . '_?[A-Z][A-Za-z0-9_]*$', $file) 
          && strcmp( $file, 'CVS' )  
          && strcmp( $file, '^MAIN' )) {
         //It's stupid we have to build the array this way, but there IS a
         //bug in this version of PHP (4.0.3)
         $file = str_replace('^', '', $file);
         $file_list = array_merge( $file_list, array( 0 => $file ));
         // $file_list[] = $file;  //I'd much rather build the array this way.
      }
   }
   $d -> close();
   $d = dir($OURLIBS);
   while( $file = $d->read() ) {
      if( ereg('^=_?[A-Z][A-Za-z0-9_]*$', $file) 
          && strcmp( $file, 'CVS' )  
          && strcmp( $file, '^MAIN' )) {
         //It's stupid we have to build the array this way, but there IS a
         //bug in this version of PHP (4.0.3)
         $file = str_replace('^', '', $file);
         $file_list = array_merge( $file_list, array( 0 => $file ));
         // $file_list[] = $file;  //I'd much rather build the array this way.
      }
   }
   $d -> close();
   return $file_list;
}

function parse_dynamic_tag( $tag, $tagfile ) {
   srand( (double) microtime() * 1000000 );
   $tagfile_contents = '';
   $funcname = "dynamic${tag}_" . rand( 0, 99999999 );
   $tagfile_contents .= @implode('', file( $tagfile ));
   $funcdef_contents = "function $funcname() {\n";
   $funcdef_contents .= "global \$OURLIBS, \$OURGFXURL, \$OURURL;\n";
   $funcdef_contents .= "global \$ROOTLIBS, \$ROOTGFXURL, \$ROOTURL;\n";
   $funcdef_contents .= "global \$THISURL;\n";
   $funcdef_contents .= "extract( \$GLOBALS[ \"HTTP_GET_VARS\" ] );\n";
   $funcdef_contents .= "extract( \$GLOBALS[ \"HTTP_POST_VARS\" ] );\n";
   $funcdef_contents .= $tagfile_contents;
   $funcdef_contents .= "}\n";
   eval( $funcdef_contents );
   ob_start();
   eval( "\$result = $funcname();" );
   $file_contents = ob_get_contents();
   ob_end_clean();
   return( $file_contents );
}

function parse_file_array( $file_array, $workingset, $OURLIBS, $directory, $prefix = '') {
   if( count($file_array) > 0 ) {
      while( list($i, $tag) = each($file_array) ) {
         if( $tag[0] == '_' ) {
            $file_contents = parse_dynamic_tag( $tag, $directory . '/' . $prefix . $tag );
         }
         elseif( $tag[0] == '=' && $tag[1] == '_' ) {
            $shavedtag = substr( $tag, 1, strlen( $tag ));
            $file_contents = parse_dynamic_tag( $shavedtag, $OURLIBS . '/' . $tag );
         }
         elseif( $tag[0] == '=' ) {
            $file_contents = @implode('', file( $OURLIBS . '/' . $tag ));
         }
         else {
            $file_contents = @implode('', file( "$directory/$prefix$tag" ));
         }
         $search = '/{'.$tag.'}/';
         $workingset = preg_replace( $search, $file_contents, $workingset);
      }
   }
   return $workingset;
}

function process($OURLIBS, $directory, $workingset, $prefix = '') {
   $files = get_file_list($directory, $prefix);
   $recursive_list = array();
   do {
      unset($todo_list);
      $tags_list = get_needed_tags_list($workingset);
      $tags_list = array_unique( $tags_list );
      $unfound_list = array_diff( $tags_list, $files );
      $tags_list = array_intersect( $tags_list, $files );
      while( list($i, $tag) = each($tags_list) ) {
         if( $tag[0] != '_' && $tag[0] != '=' ) {
            $file_contents = implode( '', file( $directory.'/'.$prefix.$tag ));
            if( strstr( $file_contents, '{' . $tag . '}' ) ) {
               $recursive_list = array_unique( array_merge( $recursive_list, array( 0 => $tag )));
            }
         }
      }
      $todo_list = array_diff($tags_list, $recursive_list);
      $workingset = parse_file_array( $todo_list, $workingset, $OURLIBS, $directory, $prefix );
   } while( count($todo_list) > 0 );
   $workingset = parse_file_array( $recursive_list, $workingset, $OURLIBS, $directory, $prefix );
   unset($unfound_list, $recursive_list, $todo_list);
   return $workingset;
}

function gzip_accepted() {
   global $HTTP_ACCEPT_ENCODING;
   if (strpos($HTTP_ACCEPT_ENCODING, 'gzip') === false) {
      return false;
   }
   if (strpos($HTTP_ACCEPT_ENCODING, 'x-gzip') === false) {
      $encoding = 'gzip';
   } 
   else {
      $encoding = 'x-gzip';
   }
   return $encoding;
}

?>